]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
Added python3 macros
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
415f4a1a 2# PLD Linux rpm macros
d54662bf 3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
46763914
ER
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 14
36eccf0d
ER
15%__rm /bin/rm --interactive=never
16
33040789 17# Build system path macros.
18#
bddadece
JB
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
f93109a0 21%__autopoint autopoint --force
22
83094b62 23%__gettextize { \
8a995cff 24 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 25 gettextize --copy --force --no-changelog; \
97589b6e 26 else \
3241033b 27 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
28 fi; \
29 if [ ! -f po/Makevars ]; then \
3241033b 30 cp -f po/Makevars{.template,}; \
8a995cff 31 fi; \
8a995cff 32}
f93109a0 33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
fb59e475 36%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
c26f1b59 39%__libtoolize libtoolize --copy --force --install
33040789 40
384e1b2b 41# Path to top of build area.
f5f7156a 42%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
384e1b2b 43
81e450f7
ER
44# The number of cvs changelog entries kept when building package.
45%_buildchangelogtruncate 20
46
6a5eda77 47%dependencytracking %{nil}
3241033b 48
e5da9169
ER
49# Relations between package names that cause dependency loops
50# with legacy packages that cannot be fixed. Relations are
51# specified as
52# p>q
53# where package p has a Requires: on something that package q Provides:
54#
55# XXX Note: that there cannot be any whitespace within the string "p>q",
56# and that both p and q are package names (i.e. no version/release).
57%_dependency_whiteout %{nil}
58
7bf0526c 59%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
c9d403e1 60 && RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
19f42054 61 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$(($RPM_BUILD_NCPUS * 2))")
810fa5c4 62
63#-----------------------------------------------------------------
64#
65# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
66# BuildRequires: awk
67# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 68#
69# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 70# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
71# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 72# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 73# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 74#
75# Regular expressions are supported, but to avoid some character be treated
76# as regular expression it must be escaped twice.
77
78%filter_out \
7b6f1112 79 for (i = 1; i in I; i++) { A=0; \
810fa5c4 80 for (f in F) { \
81 if (I[i] ~ "^" F[f] "$") A=1; \
82 }; \
83 if (!A) printf(I[i] FS); \
84 }
85
86%rpmcflags %(awk 'BEGIN {
87 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 88 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 89 %{filter_out}
90}')
91
92%rpmcxxflags %(awk 'BEGIN {
09a90176 93 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 95 %{filter_out}
96}')
97
98e7f050
AM
98%rpmcppflags %(awk 'BEGIN {
99 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101 %{filter_out}
102}')
103
810fa5c4 104%rpmldflags %(awk 'BEGIN {
c05a0741 105 split("%{?optldflags}",I);
810fa5c4 106 split("%{?filterout_ld}",F)
107 %{filter_out}
108}')
109
25f52d1a 110# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111# but, don't use it, better use gcc as linker
112%ld_rpmldflags %(awk 'BEGIN {
113 split("%{rpmldflags}",F);
114 for (f in F) {
115 s = F[f];
116 if (s ~ /^-Wl,/) {
117 s = substr(s,5);
118 gsub(/,/," ",s);
119 };
120 printf(s FS);
121 };
122}')
123
8ef644e5 124#-----------------------------------------------------------------
125#
126# Generate a command which cleans environment, leaving only the
127# most important variables.
128# If any spec requires any additional environment it should
129# redefine %_preserve_env in following manner:
130#
131# # ADDITIONAL_VAR is required because [a good reason here]
242da3b6 132# %define _preserve_env %_preserve_env_base ADDITIONAL_VAR
8ef644e5 133
242da3b6
JR
134%_preserve_env_base PATH HOME TMP TMPDIR
135%_preserve_env %_preserve_env_base
8ef644e5 136
e9c11f22 137%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
a363d727
ER
138 split("%{?_preserve_env:%_preserve_env}", P);
139 for (i in P) {
140 p = P[i];
141 if (ENVIRON[p]) {
e9c11f22 142 split( ENVIRON[p], V, "" );
143 val = p "=";
144 for ( j = 1; j in V; j++ ) {
145 v = V[j];
146 if ( v == q )
147 v = qq;
148 else if ( v == "\\"" )
149 v = q2q;
150 else if ( v == "\\\\" )
151 v = "\\\\\\\\";
152 else
e82fb4ab 153 gsub( "[^a-zA-Z0-9/:._-]", "\\"&\\"", v );
e9c11f22 154 val = val "" v;
155 }
156 printf( val " " );
8ef644e5 157 }
158 }
159}')
160
9c404149 161#-----------------------------------------------------------------
9f4ce098 162%configure2_13 { \
9c404149
AM
163 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
164 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
165 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 166 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 167 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 168 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 169 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
170 %{?__cc:CC="%{__cc}" ; export CC ; } \
171 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 172 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 173 --host=%{_target_platform} \
9c404149
AM
174 --prefix=%{_prefix} \
175 --exec-prefix=%{_exec_prefix} \
176 --bindir=%{_bindir} \
177 --sbindir=%{_sbindir} \
178 --sysconfdir=%{_sysconfdir} \
179 --datadir=%{_datadir} \
180 --includedir=%{_includedir} \
181 --libdir=%{_libdir} \
182 --libexecdir=%{_libexecdir} \
183 --localstatedir=%{_localstatedir} \
184 --sharedstatedir=%{_sharedstatedir} \
185 --mandir=%{_mandir} \
186 --infodir=%{_infodir} \
b6c5da52 187 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 188 %{dependencytracking} \
9c404149
AM
189}
190
89f4ca1f 191%__cmake /usr/bin/cmake
39b9534b
ER
192%cmake { \
193CC="%{__cc}" \
194CXX="%{__cxx}" \
195CFLAGS="%{rpmcflags}" \
196CXXFLAGS="%{rpmcxxflags}" \
12513dc1 197LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
198%{__cmake} \
199}
200
201# override __scons to add -j4 in your ~/.rpmmacros for parallel make
202%__scons /usr/bin/scons
203%scons { \
204%{__scons} \
5c76736d
ER
205 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
206 CFLAGS="${CFLAGS:-%rpmcflags}" \
207 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
208 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 209 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
210 %{?__cc:CC="%{__cc}"} \
211 %{?__cxx:CXX="%{__cxx}"} \
212 libsuffix=%{_lib} \
213 prefix=%{_prefix} \
39b9534b
ER
214}
215
6339d32d 216# waf. see waf.spec
89f4ca1f 217# override __waf to add -j4 in your ~/.rpmmacros for parallel make
6339d32d
ER
218%__waf /usr/bin/waf
219%waf { \
6339d32d
ER
220CC="%{__cc}" \
221CXX="%{__cxx}" \
9e244007 222CPP="%{__cpp}" \
6339d32d
ER
223CFLAGS="%{rpmcflags}" \
224CXXFLAGS="%{rpmcxxflags}" \
225%{__waf} \
6339d32d
ER
226}
227
4a6b0d54 228#----------------------------------------------------------------
9bacbb5b 229#%configure_cache 0
fe6c4bdd 230%configure_cache_file %{buildroot}.configure.cache
73f832b3 231
e84cd836 232%configure {./configure \
4a6b0d54
AF
233 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
234 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 235 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 236 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 237 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 238 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
239 %{?__cc:CC="%{__cc}"} \
240 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 241 --host=%{_target_platform} \
4a6b0d54
AF
242 --build=%{_target_platform} \
243 --prefix=%{_prefix} \
244 --exec-prefix=%{_exec_prefix} \
245 --bindir=%{_bindir} \
246 --sbindir=%{_sbindir} \
247 --sysconfdir=%{_sysconfdir} \
248 --datadir=%{_datadir} \
249 --includedir=%{_includedir} \
250 --libdir=%{_libdir} \
251 --libexecdir=%{_libexecdir} \
252 --localstatedir=%{_localstatedir} \
253 --sharedstatedir=%{_sharedstatedir} \
254 --mandir=%{_mandir} \
255 --infodir=%{_infodir} \
b6c5da52 256 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 257 %{dependencytracking} \
9bacbb5b 258 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
259}
260
b3b1397b
ER
261# overload to insert debuginfo package
262%prep \
263%if 0%{?_enable_debug_packages}\
264%{debug_package}\
265%endif\
266%%prep\
267%{nil}
268
9c404149 269# Location of autoconf macros
7f0f4a79 270%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 271
e2804f99 272# Location of omf files
7f0f4a79 273%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 274
e987a186 275# Location of pkgconfig files
9a4e877a 276%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
277# noarch pkgconfig files
278%_npkgconfigdir /usr/share/pkgconfig
e987a186 279
486b0b5f 280# Location of desktop files
281%_desktopdir /usr/share/applications
86dff2d0 282%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 283
481463e9 284# Location of pixmaps for applnk/desktop files
e1f0a822 285%_pixmapsdir /usr/share/pixmaps
9c404149 286
481463e9 287# Location of themable icons for applnk/desktop files
b36c8e2a 288%_iconsdir /usr/share/icons
289
e987a186
JB
290# Location of fonts directories
291%_fontsdir /usr/share/fonts
292
b3282f3f 293# Location of Gtk and associated libraries documentation
fe6c4bdd 294%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 295
fc4d7771 296# Location of KDE documentation
fe6c4bdd 297%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 298
5869828c 299# unsermake script
300%__unsermake /usr/share/unsermake/unsermake
301
9c404149 302# Current date
8cf161e2 303%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 304
9c404149
AM
305# Example files, programs, scripts...
306%_examplesdir /usr/src/examples
307
c8f7e820 308# Alternative kernel type/version
261729d9 309%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 310
8377d27d 311# The directory holding Linux kernel sources
261729d9 312%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 313
9c404149 314# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 315%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 316
8bf3719d 317
f5f7156a
ER
318%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
319%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
320%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
730239f9
ER
321%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
322%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
323%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 324
410df6e8
ER
325# Requires name = version-release
326%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 327# Requires: name = version
91d2f1eb 328%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 329# Requires: name = version (version based on querying package %2)
0d3e64c0 330%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 331
c94807f3 332%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 333
334# kernel version-release handling
95125403
ER
335%__kernel_ver %{expand:%%global __kernel_ver %( \\
336 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
337 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
338 echo ${Z:-ERROR}; \\
1a7d3518 339)}%__kernel_ver
95125403 340
c94807f3
ER
341%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
342%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
343%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
344%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 345
6262f001
ER
346# `uname -r` to be used in @release field
347%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
348
e00dd7f6 349# sgml macros
3241033b
ER
350%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
351%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
352%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
353%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
354%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
355%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 356%docbook_sgmlcat_fix() { for l in \
357'' \
358' -- default decl --' \
359'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
360' -- hacks for opensp --' \
361'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
362'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
363'' \
364; do echo $l; done >> %1 \
365}
366
eea64748
ER
367# vim - "
368
4f044018
ER
369# minimum file size needed for compressed documents.
370# just smaller files than this get larger when compressed.
a88ae20f
ER
371# some stats:
372# - 0 byte file compressed was 25 bytes .gz
373# - 39 byte file was compressed as 57
374# - with test/test.spec@man 158 byte file was compressed also 158
375%_min_compress_bytes 159
4f044018 376
9c404149
AM
377#-----------------------------------------------------------------
378# find and gzip all files in %{_mandir} and %{infodir}
379#
380# Requires: xargs, find
381#
382#%no_install_post_compress_docs 1
383%__spec_install_post_compress_docs { \
53d5af13 384%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 385 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 386 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 387 echo "Compress man pages: $i"; \
4f044018
ER
388 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
389 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
390 find $RPM_BUILD_ROOT$i -type l | while read a; do \
391 m=$(readlink $a); \
392 rm -f $a; \
393 echo .so ${m##*/} > $a; \
394 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
395 done; \
4f044018 396 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
397 fi; \
398 done; \
728ad671
JB
399 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
400 echo "Compress info pages: %{_infodir}"; \
401 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
402 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
403 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 404 fi; \
53d5af13 405}; __spec_install_post_compress_docs } }
9c404149
AM
406
407#-----------------------------------------------------------------
408# Strip executable binaries and shared object files
409#
410# Requires: find, awk, strip, cut, xargs
411#
a2ad2754
JB
412# Special macros which affect this process:
413#%no_install_post_strip 1 # disable stripping at all
414#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
415#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
416#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
417#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
418#
9c404149 419%__spec_install_post_strip {%{!?debug: \
53d5af13 420%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 421if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
422 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
423 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
424 if [ "$modulelist" ]; then \
425 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 426 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
427 echo "$modulelist" | xargs -l512 chmod u+w; \
428 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
429 echo "DONE"; \
430 fi; \
eea64748 431 fi; \
0ac49134 432 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
433 if [ -n "$filelist" ]; then \
434 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
435 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
436 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 437 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 438 if [ -n "$elfexelist" ]; then \
4d5370ac 439 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
440 chmod u+w $elfexelist; \
441 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
442 echo "DONE"; \
443 fi; \
444 if [ -n "$elfsharedlist" ]; then \
4d5370ac 445 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
446 chmod u+w $elfsharedlist; \
447 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
448 echo "DONE"; \
449 fi; \
450 if [ -n "$archiveslist" ]; then \
4d5370ac 451 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
452 chmod u+w $archiveslist; \
453 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
454 echo "DONE"; \
455 fi; \
98a06bad 456 fi; \
0ac49134
ER
457 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
458 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
459 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 460 if [ -n "$filelist_all" ]; then \
4d5370ac 461 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 462 chmod u+w $filelist_all; \
f89ccb5f 463 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 464 echo "DONE"; \
9c404149 465 fi; \
f89ccb5f 466 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 467 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 468 chmod u+w $filelist_unneeded; \
f89ccb5f 469 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 470 echo "DONE"; \
8f74418b 471 fi; \
f89ccb5f 472 if [ -n "$filelist_debug" ]; then \
4d5370ac 473 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 474 chmod u+w $filelist_debug; \
f89ccb5f 475 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 476 echo "DONE"; \
9f0d4f36 477 fi; \
53d5af13 478fi; }; __spec_install_post_strip } } }
3241033b 479
fc5d7e20 480#-----------------------------------------------------------------
481# remove all RPATH from executable binaries and shared object files
482#
483# Requires: find, awk, cut, xargs, chrpath, uname
484#
a2ad2754
JB
485# Special macros which affect this process
486#%no_install_post_chrpath 1 # disable chrpath at all
487#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
488#
fc5d7e20 489%__spec_install_post_chrpath {%{!?debug: \
53d5af13 490%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 491if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 492 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 493 if [ -n "$files" ]; then \
d5517264 494 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 495 fi; \
98a06bad 496 if [ -n "$objs" ]; then \
4d5370ac 497 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
498 echo "$objs" | \
499 while read file; do \
500 rpath= ; \
501 chmod u+w "$file"; \
5541bf26 502 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
503 case $dir in \
504 '$ORIGIN' ) \
505 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
506 else rpath="$rpath:$dir" ; fi ; \
507 continue ; \
508 ;; \
509 esac ; \
f9abaddb
AM
510 newdir=$(readlink -m "$dir"); \
511 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
512 case $dir in \
513 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
514 echo "remove-rpath: $dir in $file"; \
515 ;; \
516 * ) \
517 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
518 else rpath="$rpath:$dir" ; fi ; \
519 ;; \
520 esac ; \
521 done ; \
522 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
523 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
524 done; \
525 fi; \
53d5af13 526fi; }; __spec_install_post_chrpath } } }
3241033b 527
d366d7e0
AM
528#-----------------------------------------------------------------
529# Find all shared object files with unresolved symbols. Warn
530# and terminate if any found (termination can be turned off by define).
531#%no_install_post_check_so 1
532%__spec_install_post_check_so { \
533 __spec_install_post_check_so() { \
534 fail=0; \
535 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 536 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 537 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
538 done ; \
539 echo " DONE"; \
14ae3117 540 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
541}; __spec_install_post_check_so }}
542
d72c185f 543#-----------------------------------------------------------------
ccb8ae8d 544# Find and gzip all kernel modules
545#
546# Requires: find
547#
fe6c4bdd 548#%no_install_post_compress_modules 1
ccb8ae8d 549%__spec_install_post_compress_modules { \
53d5af13 550%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 551 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 552 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
553 if [ "$q" ]; then \
554 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
555 echo "$q" | xargs -r %{__gzip} -9nf; \
556 echo "DONE"; \
557 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
558 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
559 fi; \
3241033b 560 fi; \
53d5af13 561}; __spec_install_post_compress_modules } }
9c404149 562
ef64802f
ER
563# Remove common Perl files we don't package
564%__spec_install_post_perl_clean {\
565%{!?no_install_post_perl_clean: \
566%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
567} }
568
83094b62 569#-----------------------------------------------------------------
0e4cb4dd 570# Update GConf2 schemas
83094b62 571#
572# Requires: GConf2
573#
46885239 574%gconf_schema_install() \
307ac6c9
ER
575 umask 022; \
576 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
577 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 578%{nil}
46885239 579
580%gconf_schema_uninstall() \
24336a54 581if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 582 umask 022; \
24336a54
ER
583 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
584 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 585fi; \
f93109a0 586%{nil}
587
588#-----------------------------------------------------------------
589# Update desktop MIME database
c0a4caa0 590# requires: desktop-file-utils
c3bcd10e 591%update_desktop_database() {{ \
f93109a0 592 umask 022; \
fb59e475 593 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
594};} \
595%{nil}
f93109a0 596
c3bcd10e
ER
597%update_desktop_database_post %update_desktop_database
598
599%update_desktop_database_postun() {{ \
f27cf2fd 600if [ "$1" = "0" ]; then \
c00bf95c 601 %update_desktop_database \
f27cf2fd 602fi; \
c00bf95c
MB
603};} \
604%{nil}
f93109a0 605
fb59e475 606#-----------------------------------------------------------------
607# Update shared MIME info database
608# requires: shared-mime-info
609#
c3bcd10e 610%update_mime_database() {{ \
fb59e475 611 umask 022; \
612 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
613};} \
614%{nil}
fb59e475 615
616#-----------------------------------------------------------------
617# Update icon cache
618# requires: gtk+
619#
c3bcd10e 620%update_icon_cache() {{ \
fb59e475 621 umask 022; \
072f4b80 622 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
623};} \
624%{nil}
fb59e475 625
f93109a0 626#-----------------------------------------------------------------
627# Update scrollkeeper database
628# requires: scrollkeeper
629#
630%scrollkeeper_update_post() \
f93109a0 631 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 632%{nil}
f93109a0 633
634%scrollkeeper_update_postun() \
f27cf2fd 635if [ "$1" = "0" ]; then \
f93109a0 636 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 637fi; \
f93109a0 638%{nil}
639
9c404149
AM
640#-----------------------------------------------------------------
641# post %install sequence:
642# - autodeps exceptions
643# - compress all man and info pages,
644# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 645# - compress kernel modules if any
9c404149
AM
646
647###################################################################
648# Requires/Provides automation
3e202b06 649# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 650#
2892b5df
JB
651%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
652%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
653%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
654%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
655%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 656
338726a6
JB
657#%_noautocompressdoc %{nil}
658#
8f74418b
MM
659%_missing_doc_files_terminate_build 1%{nil}
660%_unpackaged_files_terminate_build %{nil}
8781dc74 661# (X)emacs support
d77dcb61 662%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
663%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
664%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 665
02b58f60
JK
666%__php_provides %{nil}
667%__php_requires %{nil}
668%__perl_provides %{nil}
669%__perl_requires %{nil}
fa3497cd 670%__mono_provides %{nil}
671%__mono_requires %{nil}
25043cd4
AF
672
673# Perl specific macro definitions.
c94807f3
ER
674%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
675%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
676%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
677%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
678%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
679%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 680
45c00b39 681# Ruby
c94807f3
ER
682%__ruby /usr/bin/ruby
683%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
684%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
685%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
686%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
687%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
688%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
689%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 690%ruby_rdocdir /usr/share/rdoc
c94807f3 691%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
692%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
693%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 694
7ccf7643 695%php_pear_dir /usr/share/pear
7813c433 696%php_data_dir /usr/share/php
c94807f3
ER
697%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
698%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
699%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 700
0c5d1b9b 701# extract php/zend api versions
c94807f3
ER
702%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
703%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
704%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
705%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
706%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
707%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
708%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
709
710# helper macro
f952c0f3 711%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
712
713# macros for public use
714# for php extensions (php-pecl)
68b68193 715%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 716%{__php_api_requires zend_module_api} \
f952c0f3
ER
717%{__php_api_requires -v %php_major_version debug php_debug} \
718%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 719
c1b2705c
ER
720# for zend extensions
721%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 722%{__php_api_requires zend_extension_api} \
f952c0f3
ER
723%{__php_api_requires -v %php_major_version debug php_debug} \
724%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 725
934c685f
ER
726# for php pdo modules (php-pecl-PDO_*)
727%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
728
6c3b8203
ER
729# for using PHP post scripts. for PHP >= 5.0
730%php_webserver_restart \
731[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 732[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
ba1800dc
ER
733if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
734 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
735 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
736 %service -q php-fcgi restart \
737 fi \
738fi \
6c3b8203
ER
739%{nil}
740
741# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
742%php4_webserver_restart \
743[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 744[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
ba1800dc
ER
745if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
746 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
747 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
748 %service -q php-fcgi restart \
749 fi \
750fi \
6c3b8203
ER
751%{nil}
752
578e9248 753# X.org helper macros
434ab5a2
ER
754%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
755%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
756
c94807f3
ER
757%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
758%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
759%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
760%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
761%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
578e9248 762
434ab5a2 763%requires_xorg_xserver_extension \
97486460
AM
764%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
765%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
766%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
767%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
768%{nil}
769
770%requires_xorg_xserver_xinput \
97486460
AM
771%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
772%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
773%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
774%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
775%{nil}
776
777%requires_xorg_xserver_font \
97486460
AM
778%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
779%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
780%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
781%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
782%{nil}
783
784%requires_xorg_xserver_videodrv \
97486460
AM
785%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
786%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
787%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
788%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 789%{nil}
578e9248 790
25043cd4
AF
791# Python specific macro definitions.
792# python main version
2383a9da 793%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
794
795# directories
2383a9da 796%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 797%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 798%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 799%py_incdir /usr/include/python%{py_ver}
7ccf7643 800%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 801%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 802%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
803
804# pure python modules compilation
3241033b 805%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 806
3241033b 807%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
808
809# Software written in Python language require Python with main version
e63cd81d 810%pyrequires_eq() Requires: %1
25043cd4 811
4bf34b55
AF
812# Python 3.x
813# python main version
814%__python3 python3.0
815%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
816
817# directories
818%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
819%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
820%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
821%py3_incdir /usr/include/python%{py3_ver}
822%py3_sitedir %{py3_libdir}/site-packages
823%py3_sitescriptdir %{py3_scriptdir}/site-packages
824%py3_dyndir %{py3_libdir}/lib-dynload
825
826# pure python modules compilation
827%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
828
829%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
830
f12c2314 831# Hardlink binary identical .pyc and .pyo files
f12c2314 832%__spec_install_post_py_hardlink {\
53d5af13 833%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
834local a b c=0 t=0; \
835if [ -d "$RPM_BUILD_ROOT" ]; then \
836 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
837 while read a; do \
838 b="${a%.pyc}.pyo"; \
839 if cmp -s "$a" "$b"; then \
840 ln -f "$a" "$b"; \
841 c=$((c + 1)); \
842 fi; \
843 t=$((t + 1)); \
844 done < __rpm_pyc; \
845 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
846 rm -f __rpm_pyc; \
847fi; \
53d5af13 848}; __spec_install_post_py_hardlink } }
f12c2314 849
9227b3f9 850# remove python sources, so that check-files won't complain
f12c2314 851%py_postclean() \
0f82e280 852for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 853 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
854done \
855%{nil}
856
4bf34b55
AF
857%py3_postclean() \
858for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
859 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
860done \
861%{nil}
862
0fc5cff8 863# depmod macro
864%depmod() { \
f6148427 865umask 022; \
0fc5cff8 866if [ -e /boot/System.map-%1 ]; then \
3241033b 867 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 868else \
3241033b
ER
869 if [ -e /boot/System.map ]; then \
870 /sbin/depmod -a -F /boot/System.map %1; \
871 else \
872 /sbin/depmod -a %1; \
873 fi \
0fc5cff8 874fi; \
875}
876
2afc6e64 877# XMMS specific macros
c94807f3
ER
878%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
879%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
880%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
881%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
882%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
883%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
884%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
885%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
886%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
887%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
888
889%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
d1537778 890
848c0d68 891# user/group checking macros
892#
893# Usage:
894# %userremove myuser
895#
896%userremove /usr/lib/rpm/user_group.sh user del
897%groupremove /usr/lib/rpm/user_group.sh group del
898#
899# Usage:
900# if %usertestrm myuser; then
901# /usr/sbin/userdel -r myuser
902# Note:
903# use these macros only if you need to call userdel/groupdel with
904# a non-standard option or take an extra action; otherwise use the
905# %userremove/%groupremove macros
906#
907%usertestrm /usr/lib/rpm/user_group.sh user testrm
908%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
909# user group membership management macros
910#
911# Usage:
912# %addusertogroup myuser agroup
913#
914%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 915
916# banner support (useful in {pre,post}{,un} and triggers)
917#
918# Usage:
aa41c920 919# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 920# the banner text, the banner text
aa41c920
ER
921# the banner text, and following line
922#EOF
923# You can use any form of here-document, <<'EOF' <<-EOT will do.
924# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
925#
72fcfcb3 926# -a - append to the banner
a8b9562a 927# -e - send to stderr instead of stdout
628754cb 928# -n - no show banner (overrides -t)
929# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
930#
931# Tests:
932# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
933# rpm -E 'date | %banner -e banner' > m; sh -x m
934#
afb54f6c 935%banner(aent:) ( \
1b334fe4 936RPM_SCRIPTVERBOSITY=5 \
937[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
938if [ -x /usr/bin/banner.sh ]; then \
aa41c920 939 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 940else \
a8b9562a 941 CMD="cat%{-e: >&2}" \
1b334fe4 942fi \
276a7b45
ER
943eval $CMD %{?2:%2}%{?3: %3}) \
944%{nil}
628754cb 945
990bd03f 946# useradd/groupadd macros
4c73bc69 947# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
948#
949# Usage:
950# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
951# [-g initial_group] [-G group[,...]] login
952#
953# -u uid. REQUIRED
954# -g gid/group. REQUIRED
955# -s defaults to /bin/false
956# -d defaults to /usr/share/empty
957# -c No default
958# -r is accepted but ignored (it's always set)
6bd4c218 959# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
960# rpm specific flags
961# -P package name. defaults to %{name}
962#
90627280 963%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
964%{!-u:%{error:useradd: Required argument -u missing}} \
965%{!-g:%{error:useradd: Required argument -g missing}} \
966%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
967if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
968 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
969 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
970 exit 1 \
971 fi \
972else \
973 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
974 /usr/sbin/useradd \\\
b5a7d552 975 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
976 -u %{-u*} \\\
977 -r \\\
978 -d %{-d*}%{!-d:/usr/share/empty} \\\
979 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 980 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
981 -g %{-g*} \\\
982 %{-M} \\\
983 %{-G:-G %{-G*}} \\\
1aac682a 984 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 985 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280
ER
986fi;
987
90627280
ER
988# Usage:
989# %groupadd [-P package] [-g gid] group
990#
991# -g gid. REQUIRED
992#
993# Sample:
994# %groupadd -P %{name}-base -g %{gid} %{name}
995
996%groupadd(g:P:rfo) \
9ba02ba9
ER
997%{!-g:%{error:groupadd: Required argument -g missing}} \
998%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 999if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1000 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1001 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1002 exit 1 \
1003 fi \
1004else \
1005 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1006 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1007 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1008fi;
7cb77741 1009
7c50f037 1010# webapp macros
4c73bc69 1011# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1012#
1013# The config is installed/removed inside trigger, this means that you can any
1014# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1015# updated. if you don't need the config for various reason for specific
35663282
ER
1016# webserver, just remove the symlink from config directory using webapp
1017# program. the trigger will not recreate the symlink on upgrades. In other
1018# words the config is linked to webserver config directory on first install of
1019# PACKAGE or WEBSERVER.
1020#
7c50f037
ER
1021# Add package's webserver config to webserver webapps dir.
1022# Usage:
df979130 1023# %webapp_register WEBSERVER WEBAPP
35663282
ER
1024#
1025%webapp_register() \
1026%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1027if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1028 /usr/sbin/webapp register %1 %2\
1029fi\
694a8f2e 1030# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1031if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1032 %{expand:%service -q %%1 reload}\
35663282
ER
1033fi\
1034%{nil}
1035
1036# Remove package's config from webserver webapps dir.
35663282 1037# Usage:
531c0efc
ER
1038# %webapp_register [-f] WEBSERVER WEBAPP
1039%webapp_unregister(f) \
35663282
ER
1040%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1041# remove link if either of the packages are gone \
5d3a09a3 1042if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1043 /usr/sbin/webapp unregister %1 %2\
16897aea 1044 %{expand:%service -q %%1 reload}\
35663282
ER
1045fi \
1046%{nil}
1047
462b26fa 1048# service macro.
4c73bc69 1049# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1050#
1051# calls usual service restart on package %post, but skips the restart if
1052# administrator has disabled automatic service restarts in either global
1053# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1054#
462b26fa 1055# Usage:
7377b5ca 1056# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1057#
a0bbe604 1058# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1059# -n NOOP mode, do not actually restart service
462b26fa 1060#
7377b5ca
ER
1061# Requirements:
1062# BuildRequires: rpmbuild(macros) >= 1.268
1063# Requires: rc-scripts
1064# -n option:
1065# BuildRequires: rpmbuild(macros) >= 1.450
1066%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1067
1068
f9aa75bf
ER
1069# Java macros. based on jpackage macros.java
1070#
1071# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1072%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1073
1074# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1075%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1076
1077# Root directory for all Java VM/SDK/JRE's private things.
1078%_jvmprivdir %{_libdir}/jvm-private
1079
1080# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1081%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1082
1083# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1084%_jvmdatadir %{_datadir}/jvm
1085
1086# Root directory for all configurations parts of Java VM/SDK/JRE's
1087%_jvmsysconfdir %{_sysconfdir}/jvm
1088
1089# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1090%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1091
1092# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1093%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1094
1095# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1096%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1097
1098# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1099%_jnidir %{_libdir}/java
f9aa75bf 1100
c94807f3 1101%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1102
a9254650 1103%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1104%jar %{java_home}/bin/jar
c94807f3 1105%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1106%javac %{java_home}/bin/javac
1107%javadoc %{java_home}/bin/javadoc
6aedae62 1108
fe6c4bdd 1109%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1110
1111%jpackage_script() \
3ca65b87
ER
1112install -d $RPM_BUILD_ROOT%{_bindir}\
1113cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1114#!/bin/sh\
1115#\
1116# %{name} script\
1117# JPackage Project <http://www.jpackage.org/>\
1118\
1119# Source functions library\
1120. %{_javadir}-utils/java-functions\
1121\
1122# Source system prefs\
3ca65b87 1123if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1124 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1125fi\
1126\
1127# Source user prefs\
3ca65b87
ER
1128if [ -f $HOME/.%{name}rc ]; then\
1129 . $HOME/.%{name}rc\
6aedae62
ER
1130fi\
1131\
1132# Configuration\
1133MAIN_CLASS=%1\
1134BASE_FLAGS=%2\
1135BASE_OPTIONS=%3\
3ca65b87 1136BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1137\
1138# Set parameters\
1139set_jvm\
3ca65b87
ER
1140set_classpath $BASE_JARS\
1141set_flags $BASE_FLAGS\
1142set_options $BASE_OPTIONS\
6aedae62
ER
1143\
1144# Let's start\
3ca65b87 1145run "$@"\
6aedae62
ER
1146EOF
1147
06f11871
ER
1148# jpackage 1.7
1149# Directory for maven depmaps
1150#
1151%_mavendepmapdir /etc/maven
1152%_mavendepmapfragdir /etc/maven/fragments
1153
1154#
1155# add_to_depmap adds an entry to the depmap. The arguments are:
1156#
1157# %1 the original groupid
1158# %2 the original artifact id
1159# %3 the version
1160# %4 the new groupid
1161# %5 the new artifactid
1162#
1163
1164%add_to_maven_depmap() \
1165install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1166cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1167<dependency>\
1168 <maven>\
1169 <groupId>%1</groupId>\
1170 <artifactId>%2</artifactId>\
1171 <version>%3</version>\
1172 </maven>\
1173 <jpp>\
1174 <groupId>%4</groupId>\
1175 <artifactId>%5</artifactId>\
1176 <version>%3</version>\
1177 </jpp>\
1178</dependency>\
1179\
1180EOF\
1181%{nil}
1182
1183#==============================================================================
1184#
1185# update_maven_depmap updates the main maven depmap
1186#
1187%update_maven_depmap() \
1188echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1189if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1190cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1191fi\
1192echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1193
1194
59d3ebe9 1195# PEAR install macros
4c73bc69 1196# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1197#
1198# Usage:
f7ecf326 1199# %%pear_package_setup ...
dfce8b19 1200#
59d3ebe9 1201# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1202# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1203# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1204# -D - pass -D to %setup (so the build dir is not removed)
1205# -c - register channel from local channel.xml file
dfce8b19
ER
1206#
1207# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1208# destination hierarchy. you should copy the tree to buildroot after
1209# patching/reorganizing with %%pear_package_install.
1210#
1211# additionally BUILDROOT is stripped from files and files are converted to UNIX
1212# line endings.
1213#
1214# the pear install process output is recorded to install.log, you should put it
8763f51e 1215# to %%doc for later debug or just for information.
dfce8b19
ER
1216#
1217# additionally additional-packages.txt is produced if it was detected that the
1218# package has optional dependencies. the file format is suitable of displaying
1219# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1220# automatically added for this file.
59d3ebe9
ER
1221
1222
1223# records install.log and transforms PEAR names to PLD Linux rpm package names.
1224%__pear_install_log \
1225tee install.log \
1226# make post message of optional packages \
f64d1bb2 1227grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1228if [ -s optional-packages.txt ]; then \
1229 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1230else \
1231 rm -f optional-packages.txt \
1232fi \
1233%{nil}
1234
1235# command invoking pear cli
1236%__pear /usr/bin/pear
1237
67a089ff 1238%pear_install(a:n:zD) \
59d3ebe9 1239%__pear \\\
f7ecf326 1240 -c %{builddir}/pearrc \\\
dfce8b19 1241 -d doc_dir=/docs \\\
f7ecf326
ER
1242 -d temp_dir=/tmp \\\
1243 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1244 -d bin_dir=%{_bindir} \\\
1245 -d data_dir=%{php_pear_dir}/data \\\
1246 -d test_dir=%{php_pear_dir}/tests \\\
1247 install \\\
59d3ebe9 1248 --packagingroot=%{builddir} \\\
dfce8b19
ER
1249 --offline \\\
1250 --nodeps \\\
1251 %{-f:--force} \\\
67a089ff 1252 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1253 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1254%{nil}
1255
1256# The main macro.
1257# using this macro will append optional-packages.txt to the nocompressdoc list
1258# as it's displayed to user after package install. and adding additional gzip
1259# dep is just waste ;)
f7ecf326 1260%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1261%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1262%define builddir %{_builddir}/%{srcdir} \
1263%setup -q -c -T %{-D:-D} -n %{srcdir} \
1264%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1265%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1266%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1267%pear_install \
59d3ebe9
ER
1268%{-z:cd ..} \
1269cat %{-z:$_N/}.install.log | %__pear_install_log \
1270\
dfce8b19 1271# undos sources \
2a80e4cf 1272find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1273%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1274%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1275%{nil}
1276
7bef60e8 1277# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1278# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1279%pear_package_install() \
1280cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1281find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1282# help the developer out a little: \
1283if [ -f _noautoreq ]; then \
1284 echo "AutoReqdep detected:" \
1285 echo "_noautoreq $(cat _noautoreq)" \
1286fi \
1287%{nil}
1288
0d5dd00c
ER
1289
1290# Register OpenLDAP schema.
4c73bc69 1291# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1292#
1293# Usage:
1294# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1295#
1296# -d specify dependant schemas, separated by comma
1297#
1298%openldap_schema_register(d:) \
1299for schema in %*; do \
1300 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1301 %{__sed} -i -e " \
1302 /^include.*local.schema/{ \
1303 iinclude\\t $schema\
1304 } \
1305 " /etc/openldap/slapd.conf \
1306 fi \
1307done \
1308# enable dependant schemas \
1309if [ "%{-d*}" ]; then \
1310 %{__sed} -i -e ' \
1311 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1312 s/^#// \
1313 }' /etc/openldap/slapd.conf \
1314fi \
1315%{nil}
1316
1317# Unregister OpenLDAP schema.
4c73bc69 1318# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1319#
1320# Usage:
1321# %%openldap_schema_unregister %{schemadir}/horde.schema
1322#
1323%openldap_schema_unregister() \
1324for schema in %*; do \
1325 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1326 %{__sed} -i -e " \
1327 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1328 # for symmetry it would be nice if we disable enabled schemas in post, \
1329 # but we really can not do that, it would break something else. \
1330 " /etc/openldap/slapd.conf \
1331 fi \
1332done \
1333%{nil}
1334
b0bc2936 1335%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1336
dcc6baf7 1337
1338# Build modules for kernels 2.6
1339# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1340#
1341# Usage:
aa559e46 1342# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1343#
1344# remember that proper Makefile is still required
1345# Options:
990bd03f 1346# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1347# without .ko extension, may be placed in subdirectory
aa559e46 1348# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1349# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1350# -c -- do not execute make clean
dcc6baf7 1351# <additional arguments> -- all additional arguments will be passed to
1352# make modules
1353#
1354# Additional patching supported via here document. Try:
1355# %build_kernel_modules -m module <<'EOF'
1356# your patch script here
1357# EOF
1358# Don't use it unless patching depends on config options.
1359
1360# Developer note: don't touch it unless you know how to handle '\'.
1361# - \ in script expands to nothing
1362# - \\\ in script expands to \
566398b4 1363# - \\\ inside definition expands to nothing
dcc6baf7 1364# - \\\\\\\ inside definition expands to \
1365# - in last line \ has to touch arguments so arguments passing
1366# in new lines (using \) will be supported
1367
5a81d83e 1368%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1369%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1370 \
1371%define Opts \\\\\\\
1372%if "%{_target_base_arch}" != "%{_arch}" \\\
1373 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1374 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1375 %else \\\
1376 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1377 %endif \\\
1378%else \\\
88608ef7 1379 CC="%{kgcc}" \\\
dcc6baf7 1380%endif \
88608ef7 1381%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1382 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1383 \
e364bc26 1384%{?-C:cd %{-C*}} \
dcc6baf7 1385compile() { \
ba9de9b2
ER
1386 local L="<" PATCH_SH; \
1387 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1388 set -e -x \
730239f9 1389 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1390 \
730239f9 1391for cfg in ${cfgs:-dist}; do \
dcc6baf7 1392 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1393 \
c546f6fb 1394 rm -rf o \
68cfe9d9 1395 install -d o/include/linux o/arch/powerpc/lib \
dcc6baf7 1396 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1397 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1398 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1399 \
1400 set +x \
1401 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1402 set -x \
1403 \
c768535c 1404 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1405 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1406 %{-p*} %{-P*} \\\
1407 %{MakeOpts} \
1408 %else \
1409 install -d o/include/config \
1410 touch o/include/config/MARKER \
588f1b0b 1411 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1412 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1413 %endif \
1414 \
5a81d83e 1415 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1416 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1417 ${1+"$@"} \\\
5a81d83e 1418 M=$PWD %{MakeOpts}} \
f635907b 1419 \
dcc6baf7 1420 %{__make} -C %{_kernelsrcdir} modules \\\
1421 ${1+"$@"} \\\
1422 M=$PWD %{MakeOpts} \
1423 \
1424 for MODULE in {%{-m*},}; do \
1425 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1426 done \
1427done \
aa559e46 1428%{?-C:cd -} \
dcc6baf7 1429} \
1430compile %{*}\
1431%{nil}
1432
1433
1434# Install kernel modules built by %build_kernel_modules
1435# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1436#
1437# Usage:
1438# %install_kernel_modules -m <modules> -d <directory>
1439#
1440# Options:
990bd03f 1441# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1442# without .ko extension, may be placed in subdirectory
1443# -d <directory> (required) -- in what subdirectory modules should be
1444# installed (eg. misc, kernel/drivers/net)
1445# -s <suffix> -- suffix to use when installing modules, useful when module
1446# with same name exists in kernel already
1447# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1448# for defining aliases, only useful with -s
dcc6baf7 1449
1450%install_kernel_modules(m:d:s:n:) \
1451%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1452%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1453%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1454 \
1455%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1456%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1457 \
b279feda 1458__install_kernel_modules() { \
730239f9 1459local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1460 \
1461for MODULE in {%{-m*},}; do \
1462 [ -n "${MODULE}" ] || continue \
730239f9
ER
1463 for cfg in ${cfgs:-dist}; do \
1464 [ "$cfg" = smp ] && suf=smp || suf= \
1465 MNAME=${MODULE##*/} \
1466 install -D ${MODULE}-$cfg.ko \\\
1467 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1468 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1469 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1470 >> %{ModprobeD}$suf/%{-n*}.conf} \
1471 done \
dcc6baf7 1472done \
b279feda 1473} \
1474__install_kernel_modules \
dcc6baf7 1475%{nil}
1476
fa65356c 1477# patchset macros
4c73bc69 1478# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1479#
1480# Usage:
1481# %patchset_source -f <seq(1) format> <start> [<end>]
1482# %patchset_patch <start> [<end>]
1483#
1484# If <end> is omited, it is assumed to be <start>.
1485#
1486# For example in preamble:
1487# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1488# and in %prep:
1489# %patchset_patch 33 44
1490
1491# generate SourceX urls from range START STOP
1492# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1493# The sources start from 10000
e91610db 1494%patchset_source(f:b:) %(
44f733ef 1495 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1496 start=$(expr $base + %1);
1497 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1498 # we need to call seq twice as it doesn't allow two formats
1499 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1500 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1501 paste %{tmpdir}/__ps{1,2};
1502 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1503) \
1504%{nil}
fa65356c
ER
1505
1506# apply sources from %patchset_source
1507# -p specify -pX for %patch line
1508# -b base offset: defaults to 10000
1509%patchset_patch(f:p:b:) %(
44f733ef 1510 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1511 start=$(expr $base + %1);
1512 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1513 echo ": patchset_patch %1%{?2: to %2}";
1514 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1515) \
1516%{nil}
fa65356c 1517
5730b44b 1518# browser plugins v2
4c73bc69 1519# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1520#
1521# Usage:
1522# %browser_plugins_add_browser <name> -p <plugindir>
1523#
1524# <name> (required) -- name of the browser. usually %{name}.
1525# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1526# -b -- default blacklists
1527# -a <arch> override arch
5730b44b
ER
1528#
1529# Example:
1530# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1531
1532%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1533%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1534%update_browser_plugins /usr/sbin/update-browser-plugins || :
1535
02ebf70f 1536%browser_plugins_add_browser(p:b:a:) \
9efd458e 1537 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1538 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1539 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1540 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1541 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1542 %{-b:cat >> $blacklist_file %{-b*}} \
1543%{nil}
1544
ad17b654
ER
1545# Helper for LUA.
1546# split string separated by space into quoted list
1547#
4c73bc69 1548# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1549#
1550# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1551%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1552
1553# adjust /etc/shells by adding and removing shells from there
4c73bc69 1554# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1555#
1556# Usage:
d9b789d9
ER
1557# %post -p <lua>
1558# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1559#
d9b789d9
ER
1560# %preun -p <lua>
1561# if arg[2] == 0 then
1562# %lua_remove_etc_shells /bin/bash /bin/rbash
1563# end
7377b5ca
ER
1564#
1565# Requirements:
d9b789d9
ER
1566# BuildRequires: rpmbuild(macros) >= 1.462
1567#
ad17b654 1568
d9b789d9 1569%lua_add_etc_shells() \
ad17b654
ER
1570t = {}\
1571f = io.open("/etc/shells", "r")\
1572if f then\
1573 for l in f:lines() do t[l]=l; end\
1574 f:close()\
1575end\
1576for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1577 if not t[s] then\
b8c0bc18 1578 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1579 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1580 end\
1581end\
1582%{nil}
1583
d9b789d9
ER
1584%lua_remove_etc_shells() \
1585t = {}\
1586f = io.open("/etc/shells", "r")\
1587if f then\
1588 for l in f:lines() do t[l]=l; end\
1589 f:close()\
1590end\
1591for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1592 print("Removing "..l.." from /etc/shells")\
1593 t[l] = nil\
1594end\
1595s=""\
1596for _, l in pairs(t) do\
1597 s=s..l.."\\n"\
1598end\
1599io.open("/etc/shells", "w"):write(s)\
1600%{nil}
1601
1602# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1603#
1604# Author: Elan Ruusamäe <glen@pld-linux.org>
1605#
1606# Usage:
1607# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1608# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1609#
1610# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1611#
1612# Requirements:
1613# BuildRequires: rpmbuild(macros) >= 1.429
1614#
1615%add_etc_shells(p) %{-p:<lua>}\
1616%{expand:%%lua_add_etc_shells %*}\
1617%{nil}
1618
ad17b654 1619%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1620%{-p:if arg[2] == 0 then}\
d9b789d9 1621%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1622%{-p:end} \
ad17b654
ER
1623%{nil}
1624
75bd6249
ER
1625# Check syntax for Python files
1626#
1627# Author: Elan Ruusamäe <glen@pld-linux.org>
1628# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1629#
1630# Usage:
1631# %py_lint src
1632#
1633# Requirements:
1634# BuildRequires: python
1635# BuildRequires: rpmbuild(macros) >= 1.469
1636
1637%py_lint() \
1638__py_lint() { \
1639find "$@" -type f -name '*.py' | python -c ' \
1640import sys \
1641import compiler \
1642\
1643err = 0\
1644for f in sys.stdin: \
1645 fd = open(f.strip()) \
1646 c = fd.read() \
1647 fd.close() \
1648 try: \
1649 compiler.parse(c) \
1650 except SyntaxError, e: \
1651 print "py_lint: %s: %s" % (f.strip(), e) \
1652 err = err + 1\
1653\
1654if err: \
1655 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1656 sys.exit(1) \
1657else: \
1658 print >> sys.stderr, "py_lint: Found no syntax errors." \
1659' \
1660}; __py_lint %* \
1661%{nil}
1662
59d3ebe9 1663# vim:ts=4 sw=4 noet syn=spec
This page took 0.536105 seconds and 4 git commands to generate.